# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NotificationScenarioConfig(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scenario_id': 'str',
        'enabled': 'bool',
        'scenario_name': 'str',
        'scenario_description': 'str',
        'scenario_category': 'str',
        'subject': 'str',
        'body': 'str'
    }

    attribute_map = {
        'scenario_id': 'scenarioId',
        'enabled': 'enabled',
        'scenario_name': 'scenarioName',
        'scenario_description': 'scenarioDescription',
        'scenario_category': 'scenarioCategory',
        'subject': 'subject',
        'body': 'body'
    }

    def __init__(self, scenario_id=None, enabled=None, scenario_name=None, scenario_description=None, scenario_category=None, subject=None, body=None):  # noqa: E501
        """NotificationScenarioConfig - a model defined in Swagger"""  # noqa: E501
        self._scenario_id = None
        self._enabled = None
        self._scenario_name = None
        self._scenario_description = None
        self._scenario_category = None
        self._subject = None
        self._body = None
        self.discriminator = None
        self.scenario_id = scenario_id
        self.enabled = enabled
        if scenario_name is not None:
            self.scenario_name = scenario_name
        if scenario_description is not None:
            self.scenario_description = scenario_description
        if scenario_category is not None:
            self.scenario_category = scenario_category
        if subject is not None:
            self.subject = subject
        if body is not None:
            self.body = body

    @property
    def scenario_id(self):
        """Gets the scenario_id of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario id  # noqa: E501

        :return: The scenario_id of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._scenario_id

    @scenario_id.setter
    def scenario_id(self, scenario_id):
        """Sets the scenario_id of this NotificationScenarioConfig.

        Notification scenario id  # noqa: E501

        :param scenario_id: The scenario_id of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """
        if scenario_id is None:
            raise ValueError("Invalid value for `scenario_id`, must not be `None`")  # noqa: E501

        self._scenario_id = scenario_id

    @property
    def enabled(self):
        """Gets the enabled of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario enabled  # noqa: E501

        :return: The enabled of this NotificationScenarioConfig.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this NotificationScenarioConfig.

        Notification scenario enabled  # noqa: E501

        :param enabled: The enabled of this NotificationScenarioConfig.  # noqa: E501
        :type: bool
        """
        if enabled is None:
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def scenario_name(self):
        """Gets the scenario_name of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario name  # noqa: E501

        :return: The scenario_name of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._scenario_name

    @scenario_name.setter
    def scenario_name(self, scenario_name):
        """Sets the scenario_name of this NotificationScenarioConfig.

        Notification scenario name  # noqa: E501

        :param scenario_name: The scenario_name of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """

        self._scenario_name = scenario_name

    @property
    def scenario_description(self):
        """Gets the scenario_description of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario description  # noqa: E501

        :return: The scenario_description of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._scenario_description

    @scenario_description.setter
    def scenario_description(self, scenario_description):
        """Sets the scenario_description of this NotificationScenarioConfig.

        Notification scenario description  # noqa: E501

        :param scenario_description: The scenario_description of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """

        self._scenario_description = scenario_description

    @property
    def scenario_category(self):
        """Gets the scenario_category of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario category  # noqa: E501

        :return: The scenario_category of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._scenario_category

    @scenario_category.setter
    def scenario_category(self, scenario_category):
        """Sets the scenario_category of this NotificationScenarioConfig.

        Notification scenario category  # noqa: E501

        :param scenario_category: The scenario_category of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """

        self._scenario_category = scenario_category

    @property
    def subject(self):
        """Gets the subject of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario subject  # noqa: E501

        :return: The subject of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this NotificationScenarioConfig.

        Notification scenario subject  # noqa: E501

        :param subject: The subject of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def body(self):
        """Gets the body of this NotificationScenarioConfig.  # noqa: E501

        Notification scenario body  # noqa: E501

        :return: The body of this NotificationScenarioConfig.  # noqa: E501
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this NotificationScenarioConfig.

        Notification scenario body  # noqa: E501

        :param body: The body of this NotificationScenarioConfig.  # noqa: E501
        :type: str
        """

        self._body = body

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NotificationScenarioConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotificationScenarioConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
